K-periodic Garland CodeForces - 1353E(贪心)

You are given a garland consisting of n lamps. States of the lamps are represented by the string s of length n. The i-th character of the string si equals ‘0’ if the i-th lamp is turned off or ‘1’ if the i-th lamp is turned on. You are also given a positive integer k.

In one move, you can choose one lamp and change its state (i.e. turn it on if it is turned off and vice versa).

The garland is called k-periodic if the distance between each pair of adjacent turned on lamps is exactly k. Consider the case k=3. Then garlands “00010010”, “1001001”, “00010” and “0” are good but garlands “00101001”, “1000001” and “01001100” are not. Note that the garland is not cyclic, i.e. the first turned on lamp is not going after the last turned on lamp and vice versa.

Your task is to find the minimum number of moves you need to make to obtain k-periodic garland from the given one.

You have to answer t independent test cases.

Input
The first line of the input contains one integer t (1≤t≤25 000) — the number of test cases. Then t test cases follow.

The first line of the test case contains two integers n and k (1≤n≤106;1≤k≤n) — the length of s and the required period. The second line of the test case contains the string s consisting of n characters ‘0’ and ‘1’.

It is guaranteed that the sum of n over all test cases does not exceed 106 (∑n≤106).

Output
For each test case, print the answer — the minimum number of moves you need to make to obtain k-periodic garland from the given one.

Example
Input
6
9 2
010001010
9 3
111100000
7 4
1111111
10 3
1001110101
1 1
1
1 1
0
Output
1
2
5
4
0
0
思路:dp不会写,只能考虑贪心了。
我们将所有的位置都变为0.因为k个位置中,1的数量最多是1个。所以我们枚举这个位置,然后不断的更新最小值。具体看代码:

#include
#define ll long long
#define inf 0x3f3f3f3f
using namespace std;

string s;
int n,k;

int main()
{
	int t;
	scanf("%d",&t);
	while(t--)
	{
		scanf("%d%d",&n,&k);
		cin>>s;
		int ans=0;
		int sum=0;
		for(int i=0;i<n;i++) sum+=(s[i]=='1');
		ans=inf;
		ans=min(ans,sum);
		for(int i=0;i<k;i++)
		{
			int cnt=0;
			for(int j=i;j<n;j+=k)
			{
				if(s[j]=='1') cnt--;
				else cnt++;
				cnt=min(cnt,0);//如果cnt>0的话,说明,这个位置上,1的个数小于0的个数,那么我们就没必要将0换位1了,可以采用将1换为0的策略。这正是贪心的体现。
				ans=min(ans,sum+cnt);
			}
		}
		cout<<ans<<endl;
	}
	return 0;
}

努力加油a啊,(o)/~

你可能感兴趣的:(K-periodic Garland CodeForces - 1353E(贪心))